﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Controls.Menus;

namespace XamDataTreeDataSet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = GenerateData().Tables["Parent"].DefaultView;
        }

        private DataSet GenerateData()
        {
            var data = new DataSet("SimpleData");
            data.EnforceConstraints = false;

            DataTable parent = new DataTable("Parent");
            
            parent.Columns.Add("ID", typeof(int));
            parent.Columns.Add("LineNumber", typeof(int));
            parent.Columns.Add("Name", typeof(string));

            parent.PrimaryKey = new[] { parent.Columns[0] };

            DataTable children = new DataTable("Children");

            children.Columns.Add("ID", typeof(int));
            children.Columns.Add("LineNumber", typeof(int));
            children.Columns.Add("Child", typeof(string));
            children.Columns.Add("Age", typeof(int));
            children.Columns.Add("Parent_ID", typeof(int));

            children.PrimaryKey = new[] { children.Columns[0] };

            data.Tables.Add(parent);
            data.Tables.Add(children);

            data.Relations.Add("Parent_Child", parent.Columns[0], children.Columns[4], false);

            for (int i = 1; i < 10; i++)
            {
                data.Tables["Parent"].Rows.Add(new object[] { i, data.Tables["Parent"].Rows.Count + data.Tables["Children"].Rows.Count, "Parent" + i });

                for (int j = 0; j < 5; j++)
                {
                    data.Tables["Children"].Rows.Add(new object[] { j, data.Tables["Parent"].Rows.Count + data.Tables["Children"].Rows.Count, "Child" + j, j + i, i });
                }
            }

            data.AcceptChanges();

            return data;
        }

        private void xamDataTree1_SelectedNodesCollectionChanged(object sender, NodeSelectionEventArgs e)
        {
            if (e.OriginalSelectedNodes.Count != 0)
            {
                e.OriginalSelectedNodes[0].IsChecked = false;
            }
            e.CurrentSelectedNodes[0].IsChecked = true;
            
        }
    }
}
